# Cyber Range Experience

![GitLab issues](https://img.shields.io/gitlab/issues/open/imagine-rit/cre/cre-deployment?gitlab_url=https%3A%2F%2Fgitlab.ritsec.cloud&style=for-the-badge&logo=gitlab)
![GitLab merge requests](https://img.shields.io/gitlab/merge-requests/open/imagine-rit/cre/cre-deployment?gitlab_url=https%3A%2F%2Fgitlab.ritsec.cloud&style=for-the-badge&logo=gitlab)
![GitLab Release (self-managed)](https://img.shields.io/gitlab/v/release/imagine-rit/cre/cre-deployment?date_order_by=created_at&gitlab_url=https%3A%2F%2Fgitlab.ritsec.cloud&include_prereleases&sort=semver&style=for-the-badge&logo=gitlab)

> This repository is used for deployment of the Cyber Range Experience, for source code please see [cre-backend](https://gitlab.ritsec.cloud/imagine-rit/cre/cre-backend) and [cre-frontend](https://gitlab.ritsec.cloud/imagine-rit/cre/cre-frontend)

## Description

The Cyber Range Experience is designed to be an all-inclusive platform for demonstrating what we do in the Computing Security/Cybersecurity department to the public. It is designed to be a platform for interactive experiences (such as modular mini-games) as well as badge distribution designed to encourage participation and visitation of other exhibits at ImagineRIT (e.g. scanning a QR code at each booth in the ESL GCI).

## Installation

The installation instructions are to be followed in order:

1. [Email Setup](#email-setup)

## Deployment

```shell
cp env.example .env
# Edit the .env file to your liking
# ...
docker compose up -d
```

## Email Setup

In order to set up email, we use the Google Gmail API. There are some prerequisites with that:

- Google/Gmail account
- Gmail API Enabled
- Oauth Consent Screen
- Oauth 2.0 Credentials

### Enable the Gmail API

Visit [Google Cloud Console -> Api's and Services -> Enabled APIs & Services](https://console.cloud.google.com/apis/dashboard). Click the **Enable APIs and Service** button. Search for `Gmail`, then click the Gmail API and enable it.

### Creating a Consent Screen

1. Visit [Google Cloud Console -> Api's and Services -> Oauth Consent Screen](https://console.cloud.google.com/apis/credentials/consent)
2. Create a new consent screen, filling in most fields with relevant deployment-specific info except:
   - Add the `.../auth/gmail.send` scope
   - Add your Google account as a test user.

### Generating Oauth Credentials

1. Visit [Google Cloud Console -> Api's and Services -> Credentials](https://console.cloud.google.com/apis/credentials)
2. Click **Create Credentials -> OAuth client ID**
3. Set the application type to **Desktop app**
4. Give the application a name
5. Click **Create**
6. Click **Download JSON** and save the file as `credentials.json`
7. Place `credentials.json` in the [`credentials/`](./credentials/) directory
8. Edit the `redirect_uris` array to contain a singular element of `http(s)://<your domain>/api/oauth/authorize` (this causes the automatic redirect when authenticating to the Gmail API on boot)

> _Note: you will need to visit the link printed in the server logs on first boot_

## Support

Please submit any issues/support requests [here](https://gitlab.ritsec.cloud/groups/imagine-rit/cre/-/issues).

## Roadmap

- [x] Basic MVP
- [x] Mini-Game Modules
- [x] QR Code Booth Tokens
- [x] Email Reports / Profiles
- [ ] Social Media Integration

## Contributing

See [CONTRIBUTING](CONTRIBUTING.md) for more information.

## Authors and acknowledgment

- [BradHacker](https://gitlab.ritsec.cloud/BradHacker)

## License

[GPLv3](https://choosealicense.com/licenses/gpl-3.0/)
